(**************************************************************************)
(*                                                                        *)
(*  This file is part of Frama-C.                                         *)
(*                                                                        *)
(*  Copyright (C) 2013                                                    *)
(*    CEA (Commissariat à l'énergie atomique et aux énergies              *)
(*         alternatives)                                                  *)
(*                                                                        *)
(*  you can redistribute it and/or modify it under the terms of the GNU   *)
(*  Lesser General Public License as published by the Free Software       *)
(*  Foundation, version 2.1.                                              *)
(*                                                                        *)
(*  It is distributed in the hope that it will be useful,                 *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU Lesser General Public License for more details.                   *)
(*                                                                        *)
(*  See the GNU Lesser General Public License version 2.1                 *)
(*  for more details (enclosed in the file licenses/LGPLv2.1).            *)
(*                                                                        *)
(**************************************************************************)
open Stdlib
open Popop.Types
open Solver

let lazy_propagation = false

(* expressionModule *)
module T = struct
  type t = unit

  let print _ = failwith "todo print"
  let compare _ =  failwith "todo compare"
  let equal _ =  failwith "todo equal"
  let hash _ = failwith "todo hash"

end
(* end *)

(* semanticModule *)
module Th  = struct
  include MkDatatype(T)
  let key = Sem.create_key  "todo key sem"
end
(* end *)

(* registringSem *)
module ThE = RegisterSem(Th)
(* end *)

module D = struct
  type t = unit

  let key = Dom.create_key  "todo types"
  let print _ =  failwith "todo print dom "
  let merge _ =  failwith "todo merge "
  let merged _ = failwith "todo merged "
end

module DE = RegisterDom(D)

module ExpProp = struct
  type t = unit

  let print _ = failwith "todo print exp "
  let analyse _ = failwith "todo analyse exp  "
  let key  = Explanation.Exp.create_key "todo key exp  "
  let expdom  _ = failwith "todo expdom exp "
end

module EP = Conflict.RegisterExp(ExpProp)

module DaemonPropa = struct
  module Data = struct
    type t = unit
    let print _ = failwith "todo print Data print "
  end

  let key  = Demon.Fast.create "todo key for daemon propa"
  let immediate = true (* failwith "todo immediate for daemon propa"*)
  let throttle = 0 (* failwith "todo throttle for daemon propa" *)
  let wakeup _ =  failwith "todo wakeup for daemon propa"
end

module RDaemonPropa = Demon.Fast.Register(DaemonPropa)

module Cho = struct
  module Key = Cl (* failwith "todo Module Key for Choice" *)
  module Data = D (* failwith "todo Module Data for Choice" *)
  let choose_decision _ = failwith "todo choose decision  for Choice"
  let make_decision _ = failwith "todo make decision  for Choice"
  let analyse _ = failwith "todo analyse  for Choice"
  let key  = Explanation.Cho.create_key "todo key for Choice"
end
module ECho = Conflict.RegisterCho(Cho)
(*
module Con = struct
  type t = unit
  let print _ = failwith "todo print Con "
  let key  =  "todo key for Con"
  let propacl _ = failwith "todo propacl for Con"
  let same_sem  _ = failwith "todo same_sem for Con"
  let finalize _ = failwith "todo finalize for Con"
end
module EC = Conflict.RegisterCon(Con)
*)
