(**************************************************************************)
(*                                                                        *)
(*  This file is part of Frama-C.                                         *)
(*                                                                        *)
(*  Copyright (C) 2013                                                    *)
(*    CEA (Commissariat à l'énergie atomique et aux énergies              *)
(*         alternatives)                                                  *)
(*                                                                        *)
(*  you can redistribute it and/or modify it under the terms of the GNU   *)
(*  Lesser General Public License as published by the Free Software       *)
(*  Foundation, version 2.1.                                              *)
(*                                                                        *)
(*  It is distributed in the hope that it will be useful,                 *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU Lesser General Public License for more details.                   *)
(*                                                                        *)
(*  See the GNU Lesser General Public License version 2.1                 *)
(*  for more details (enclosed in the file licenses/LGPLv2.1).            *)
(*                                                                        *)
(**************************************************************************)

open Popop
open Types

type t = App of Cl.t * Cl.t
val print: t Pp.printer

val sem: t sem

val fun1 :
  Ty.t -> string ->
  (Cl.t -> Cl.t)
val fun2 :
  Ty.t -> string ->
  (Cl.t -> Cl.t -> Cl.t)
val fun3 :
  Ty.t -> string ->
  (Cl.t -> Cl.t -> Cl.t -> Cl.t)
val fun4 :
  Ty.t -> string ->
  (Cl.t -> Cl.t -> Cl.t -> Cl.t -> Cl.t)
val fun5 :
  Ty.t -> string ->
  (Cl.t -> Cl.t -> Cl.t -> Cl.t -> Cl.t -> Cl.t)

val register_sort: ?dec:Variable.make_dec -> Ty.t -> unit

val fresh_fun: result:Ty.t -> arity:int -> string -> Cl.t

val app_fun: Cl.t -> Cl.t list -> Cl.t


val th_register : Solver.Delayed.t -> unit
