
let base = Filename.dirname Sys.executable_name
let resolve_path s = Filename.concat base s

let () =
  UTop.require ["zarith";"ocamlgraph";"cryptokit"];
  Topdirs.dir_install_printer Format.err_formatter
    Longident.(Ldot(Lident "Z","pp_print"));
  Topdirs.dir_install_printer Format.err_formatter
    Longident.(Ldot(Lident "Q","pp_print"));

  List.iter Topdirs.dir_directory
    (List.map resolve_path
       (List.map (Filename.concat "_build/")
          ["src";
           "src/util";
           "src/inputlang/altergo";
           "src/inputlang/dimacs_cnf";
           "src/inputlang/smtlib2";
           "tests";
           "src/cmd";
           "src/arith";
          ]));

  ignore (Topdirs.load_file Format.err_formatter
            (resolve_path "_build/src/cmd/popop_lib.cma"));
  List.iter (fun p -> Topdirs.dir_install_printer
                Format.err_formatter
                (Longident.Ldot(p,"print")))
    Longident.[Lident "Polynome";
               Ldot(Lident "Popop_types","Dom");
               Ldot(Lident "Popop_types","Sem");
               Ldot(Lident "Popop_types","Dem");
               Ldot(Lident "Popop_types","Cl");
               Ldot(Ldot(Lident "Solver","Events"),"Fired");
               Lident "Interval";
               Lident "Uninterp";
              ];

  let exec_init s =
    match UTop.parse_toplevel_phrase_default s true with
    | UTop.Value r ->
      ignore(Toploop.execute_phrase true Format.err_formatter r)
    | _ -> assert false
  in
  let init = ["open Popop;;";
              "open Types;;";] in
  let first = ref true in
  UTop.at_new_command (fun () ->
      if !first then begin
        first := false;
        List.iter exec_init init;
      end;
      
    )


(* Start utop. It never returns. *)
let () = UTop_main.main ()
