open OUnit

open Tests_lib
open Scheduler

let theories = [Variable.th_register; Uninterp.th_register; Arith.th_register]
let run = Scheduler.run_exn ~nodec:() ~theories
let ($$) f x = f x

let solve6 () =
  let a  = Variable.fresh Arith.real "ar" in
  let b  = Variable.fresh Arith.real "br" in
  let c  = Variable.fresh Arith.real "cr" in
  let f = Uninterp.fun1 Arith.real "fr" in
  let t3 = f c in
  let t3' = f b in
  let env = run $$ fun env ->
      let t1 = Arith.sub b c in
      let t1  = Arith.add a t1  in
      let t1' = Arith.cst (Q.of_int 2) in
      let t2  = a in
      let t2' = Arith.cst (Q.of_int 2) in
      register env t3';
      register env t3;
      register env t1;
      register env t1';
      register env t2;
      register env t2';
      merge env t1 t1';
      merge env t2 t2'
  in
  assert_bool "a+(b-c) = 2 => a = 2 => f b = f c"
    (Solver.Delayed.is_equal env t3 t3')



let basic = "Arith.Uninterp.Basic" &: [solve6 ]


let tests = TestList [basic]
